package vo

import "gitea.cdlsxd.cn/BaseSystem/plugin/proto"

type NotifyBizType string

const (
	NotifyBizTypeBatchPublish NotifyBizType = "V_BATCH_PUBLISH"
	NotifyBizTypeExpire       NotifyBizType = "V_EXPIRE"
	NotifyBizTypeDelete       NotifyBizType = "V_DELETE"
	NotifyBizTypeUse          NotifyBizType = "V_USE"
	NotifyBizTypeRefund       NotifyBizType = "V_REFUND"
)

var notifyBizTypeTextMap = map[NotifyBizType]string{
	NotifyBizTypeUse:          "券核销",
	NotifyBizTypeRefund:       "券退款",
	NotifyBizTypeBatchPublish: "券发放",
	NotifyBizTypeExpire:       "券过期",
	NotifyBizTypeDelete:       "券删除",
}

var notifyBizTypeMap = map[NotifyBizType]proto.Status{
	NotifyBizTypeBatchPublish: proto.Status_SUCCESS,
	NotifyBizTypeDelete:       proto.Status_DELETE,
	NotifyBizTypeExpire:       proto.Status_OVERDUE,
	NotifyBizTypeUse:          proto.Status_WRITE_OFF,
	NotifyBizTypeRefund:       proto.Status_REFUND,
}

func (o NotifyBizType) GetText() string {
	msg, ok := notifyBizTypeTextMap[o]
	if !ok {
		return ""
	}
	return msg
}

func (o NotifyBizType) GetOrderStatus() proto.Status {
	if o == "" {
		return proto.Status_INVALID
	}
	if resultStatus, ok := notifyBizTypeMap[o]; ok {
		return resultStatus
	}
	return proto.Status_FAIL
}
